#include <OLED_I2C.h>


int val;
int encoder0PinA = 11;
int encoder0PinB = 10;
unsigned char encoder0Pos = 0;
int encoder0PinALast = LOW;
int n = LOW;
int old = -1, old_se = -1;
char zero = 2;

OLED  myOLED(SDA, SCL, 8);
char mes[20] = "NONE";
extern uint8_t SmallFont[];


void setup()
{
  myOLED.begin();
  myOLED.setFont(SmallFont);
  myOLED.print(mes, CENTER, 24);
  myOLED.update();
  pinMode (encoder0PinA, INPUT);
  pinMode (encoder0PinB, INPUT);
  delay(1000);
  myOLED.clrScr();
  drawBar(28, 20, 42, 0, 255, 'G', 0);
  drawBar(52, 20, 42, 64, 255, 'B', 0);
  drawBar(76, 20, 42, 128, 255, 'W', 0);
  drawBar(100, 20, 42, 255, 255, 'Y', 0);
  myOLED.update();
}

void loop()
{

  n = digitalRead(encoder0PinA);
  if ((encoder0PinALast == HIGH) && (n ==  LOW)) {
    delay (1);
    if (digitalRead(encoder0PinB) == HIGH) {
      encoder0Pos--;
      //delay (1);
    } else {
      encoder0Pos++;
      //delay (1);
    }
    //sprintf(mes, "%d", encoder0Pos);
    //myOLED.clrScr();
    //myOLED.print(mes, CENTER, 24);
    //myOLED.print("R", 9, 48);
    //myOLED.print(mes, 3, 57);
    //myOLED.drawRect(2, 2, 12, 58);
    drawBar(4, 20, 42, encoder0Pos, 255, 'R', 1);

    //myOLED.drawLine(2,0,22,0);


    myOLED.update();
  }
  encoder0PinALast = n;
}

void drawBar(unsigned char x_pos, unsigned char sz, unsigned char hight, int stat, int max_stat,char nm, bool act)
{

  if (stat > max_stat) {
    stat = max_stat;}
  else if (stat < 0) {
      stat = 0;}

  if (stat != old) {
    myOLED.clrRect(x_pos, 2 + hight, x_pos + sz, hight + zero + 20);
    if(stat < 10) sprintf(mes, "00%d", stat);
    else if(stat >= 10 && stat < 100) sprintf(mes, "0%d", stat);
    else if(stat >= 100) sprintf(mes, "%d", stat);
    myOLED.print(mes, x_pos + 1, hight + zero + 12);

    if (act == 1) {
      sprintf(mes, ">%c<", nm);
      myOLED.print(mes, x_pos + 1, hight + zero + 4);
    }

    if (act == 0) {
      sprintf(mes, "%c", nm);
      myOLED.print(mes, x_pos + 5, hight + zero + 4);
    }

    old = stat;
    stat = ((float)stat / max_stat) * hight;
    if (stat != old_se) {    
      //myOLED.clrRect(x_pos, zero, x_pos+sz, 2+hight);
      myOLED.drawRect(x_pos, zero, x_pos + sz, 2 + hight);
      unsigned char temp = hight + zero-1;
      char temp2 = temp;
      while ( temp2 > stat)
      {
        temp2 = temp2 - 1;
        myOLED.clrLine(x_pos + 1, temp2, x_pos + sz, temp2);
      }
      temp2 = temp - stat;
      while (temp > temp2)
      {
        myOLED.drawLine(x_pos, temp, x_pos + sz, temp);
        temp = temp - 1;
        //delay(100);
        //myOLED.update();
      }
      old_se = stat;
    }
  }
}
/*myOLED.clrScr();

  myOLED.drawRect(0, 0, 127, 63);

  myOLED.print("Lower case:", LEFT, 0);
  myOLED.print("abcdefghijklm", CENTER, 16);
  myOLED.print("nopqrstuvwxyz", CENTER, 24);
  myOLED.update();
  delay (5000);

  myOLED.clrScr();
  myOLED.print("Numbers:", LEFT, 0);
  myOLED.print("0123456789", CENTER, 16);
  myOLED.update();
  delay (5000);

  myOLED.clrScr();
  myOLED.print("Special:", LEFT, 0);
  myOLED.print("!\"#$%&'()*+,-.", CENTER, 16);
  myOLED.print("/:;<=>?@[\\]^_`", CENTER, 24);
  myOLED.print("{|}~", CENTER, 32);
  myOLED.update();
  delay (5000);*/


